<?php
/*

 $Id: option.php,v 1.12 2003/08/05 23:00:03 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/option.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header DHCP Options Document
	This is a subdocment of workgoups and subnets, it is never referenced on it's own, simply called for functions.
*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
	check_session();

	setup_user_environment($action, $zone_id);

/* End House Keeping */

// Only admins and zone admins should be here
if ( ! $user->is_admin && !$user->is_zone_admin) {
        header("Location: " . $conf['web_path'] . "/index.php");
	exit();
}

show_template('header');

/*****************
 START WORK BLOCK
*****************/

// let's check to see what type we have passed to us
if ( $subnet_id ) {
	$type    = 'subnet';
	$type_id = $subnet_id;
}
elseif ( $workgroup_id ) {
	$type    = 'workgroup';
	$type_id = $workgroup_id;
}
elseif ( $host_id ) { 
	$type = 'host';
	$type_id = $host_id;
}

if ( $option_id ) {
	$option = new Option($option_id,$type);
}

// now do things based on the form data
if ( $action == 'Create' || $action == 'Update' ) {

	if (!is_object($option)) { 
		$option = new Option(0);
	}
	$option->check_option_value($dhcp_option_id,$value);

	if ( $conf['error']->error_state ) {
		// there was an error so set the appropriate action
		if ( $action == 'Create' ) {
			$action = 'show_create';
		}
		else {
			$action = 'edit';
			$option = new Option($option_id, $type);
		}

		$option->id                = $option_id;
		$option->value		   = $value;
	}
	else {
		// create/update the stinkin' option
		if ( $action == 'Create' ) {

			if ($type != 'workgroup') { 
				$sql = "INSERT INTO $type"."_option_local (dhcp_option,value,$type) ".
					"VALUES ($dhcp_option_id,'$value',$type_id)";
			}
			else {
				if (!$option_type) { $option_type = 'group'; }
				$sql = "INSERT INTO workgroup_option_local (dhcp_option,value,workgroup,type) " . 
					"VALUES ($dhcp_option_id,'$value','$type_id','$option_type')";
			}
			$db_result = mysql_query($sql, $conf['dbh']);	
			$option_id  = mysql_insert_id($conf['dbh']);
		}
		else {
			if ($type != 'workgroup') { 
				$sql = "UPDATE $type"."_option_local SET dhcp_option=$dhcp_option_id,value='$value',$type=$type_id".
				" WHERE id=$option_id";
			}
			else {
				if (!$option_type) { $option_type = 'group'; }
				$sql = "UPDATE workgroup_option_local SET dhcp_option=$dhcp_option_id,value='$value',workgroup='$type_id',type='$option_type' WHERE id='$option_id'";
			}
			
			$db_result = mysql_query($sql, $conf['dbh']);	
		}

		$action = 'show_options';
		$option = new Option($option_id, $type);
	}
}

/*!
	@function Update_Global
	@discussion do checks and then update the global option
*/
elseif ($action == 'Update Global') {

	$option->check_option_value($dhcp_option_id,$value);

	// if no errors have occured	
	if (!$conf['error']->error_state) {
		$option->update_global_option($option_id,$value,$type);
		$conf['ui']->display_confirmation("Option upated", "Global option set to $value", $conf['web_path'] . "/admin.php");
	} // no errors

	else {
		$action = 'edit_global';
	}


} // update_global

/*!
	@function Update_Host_Option
	@discussion this updates the host DHCP options... 
*/
elseif ($action == 'Update Host Option') {

	$host = new Host($option->type_id);

	if ($user->has_access($host->zone->id) >= 50) { 

	        $option->check_option_value($dhcp_option_id,$value);
		
		if (!$conf['error']->error_state) {
			$option->update_host_option($dhcp_option_id,$value,$option_id);
			$conf['ui']->display_confirmation("Option Updated", "Host Option set to $value", $conf['web_path'] . "/host.php?action=show_host_options&host_id=" . $host->id);
		} // if no errors
		else {
			$action = 'show_edit_host';
		}
	}
	else {
		$conf['ui']->show_access_denied();
	}


} // update_host_option

// this we're really deleting this zone
elseif ( $action == 'delete' && $really && ( $user->has_access($zone_id) >= 50 || $user->is_admin) ) {
	$option->delete($type);
	$action = 'show_options';
} // if we are deleting

elseif ( $action == 'edit' ) {
	$type_id = $option->type_id;
}

/*!
	@function create_host
	@discussion creates a host specifiec dhcp option
*/
elseif ($action == 'create_host') { 
	// Create the host object we need
	$host = new Host($type_id);
	$option = new Option();
	
	if ( !$user->is_admin && $user->has_access($host->zone->id) < 50 ) { 
		$conf['ui']->show_access_denied(); 
	} // if they don't have access

	// if they do have access
	else {

		$option->check_option_value($dhcp_option_id,$value);

		if (!$conf['error']->error_state) { 
			$option->create_host_option($dhcp_option_id,$value,$type_id);
			$conf['ui']->display_confirmation("Host DHCP option created", "Your Host DHCP option has been added", $conf['web_path'] . "/host.php?action=show_host&host_id=$type_id");
		}
		else {
			$action = 'show_create_host';
		}

	} // end if they have access

} // create_host

/*!
	@function create_global
        @discussion creates the global workgroup option
*/
elseif ($action == 'create_global' AND $user->is_admin) {

	// Create the needed objects
        $option = new Option();

	$option->check_option_value($dhcp_option_id,$value);

	if (!$conf['error']->error_state) { 
	        $option->create_global_option($dhcp_option_id,$value, $type);
	        $conf['ui']->display_confirmation("Global $type option created", "Your global $type option has been added", $conf['web_path'] . "/admin.php");
	}
	else {
		$action = 'show_create_global';
	}

} // create_global

/*!
	@function global_delete
	@discussion deletes a global option
*/
elseif ($action == 'global_delete' && $user->is_admin) {

	$option->delete_global_option($option_id,$type);
	$conf['ui']->display_confirmation("Global $type option delete", "Your global $type option has been deleted", $conf['web_path'] . "/admin.php");

} // global_delete

/*!
	@function really_delete_host
	@discussion this is the actual function that deletes a host_option
*/
elseif ($action == 'really_delete_host' && $user->has_access($zone_id) >= 50) {

	$option->delete_host_option($option_id);
	$conf['ui']->display_confirmation("Option Deleted", "The host option has been removed.", $conf['web_path'] . "/host.php?action=show_host_options&host_id=$host_id");

} // really_delete_host

/**************************
     START DISPLAY BLOCK
**************************/

?>
<font class="header1"><?= $title; ?></font>
<?

	$sql = "SELECT id FROM option WHERE $type=$type_id";

	if (!$user->view) {
                $user->view = new View($sql);
        }

	if ($sort_type) {
		$user->view->initialize($sort_type,$sort_offset);
        }
        else {
		$user->view->initialize('dhcp_option', $sort_offset);
        }


	if ( $action == 'edit' || $action == 'show_create' ) {
		// show the range edit form
		$conf['ui']->show_option($action, $type, $type_id, $option);
	}

	/*!
		@function edit_global
		@discussion edits global options
	*/
	if ($action == 'edit_global') {
		$option = new Option($option_id,$type,"true");
		require ($conf['prefix'] . "/templates/show_global_option.inc");

	} // edit_global

	/*!
		@function edit_host_option
		@discussion edits a host DHCP option
	*/
	elseif ($action == 'show_edit_host') { 
		$option = new Option($option_id,$type);
		require ($conf['prefix'] . "/templates/show_host_option.inc");
	} // show_host_accountant

	/*!
		@function show_create_host
		@discussion show the host create template
	*/
	elseif ($action == 'show_create_host') { 
		require ($conf['prefix'] . "/templates/show_host_option.inc");
	}

	/*!
		@function show_options
		@dicussion displays many options, based on type
	*/
	elseif ( $action == 'show_options' ) {
		$sql = "SELECT * FROM $type"."_option_local WHERE $type=$type_id";
		$db_result = mysql_query($sql, $conf['dbh']);

		$options = array();

		while ( $obj = mysql_fetch_object($db_result) ) {
			$options[] = new Option($obj->id, $type);
		}

		$conf['ui']->show_options($action, $type, $type_id, $options);
	}

	/*!
		@function show_global_options
		@discussion show global options.. duh
	*/
	elseif ($action == 'show_global_options') {
		global $conf;

		$sql = "SELECT id FROM $type"."_option_global";
		$db_results = mysql_query($sql, $conf['dbh']);

		$options = array();

		while ($r = mysql_fetch_object($db_results)) {
			$options[] = new Option($r->id,$type,"true");
		}

		$conf['ui']->show_options($action, $type,$type_id,$options);

	} // show_global_options

	/*!
		@function Delete_Global
		@discussion Delete a global option of $type
	*/
	elseif ($action == 'Delete Global' || $action =='delete_global' ) {
		$option = new Option($option_id,$type,"true");
		$conf['ui']->show_confirm($conf['web_path'] . "/option.php?action=global_delete&option_id=$option_id&type=$type", "Are you sure you want to delete this DHCP option? ($option->dhcp_option_name with value $option->value)");


	} // delete_global

	/*!
		@function Delete_Host
		@discussion Shows a confirmation for deleting a host dhcp optoin
	*/
	elseif ($action == 'Delete Host Option' || $action == 'delete_host' ) {

		$conf['ui']->show_confirm($conf['web_path'] . "/option.php?action=really_delete_host&option_id=$option_id&zone_id=$zone_id&type=host&host_id=$host_id", "Are you sure you want to delete this option?");		

	} // delete_host	

	elseif ( $action == 'delete' || $action == 'Delete' ) {
		// show the confirm delete
		$option  = new Option($option_id, $type);
		if ($type == 'workgroup') { 
			$workgroup = new Workgroup($option->type_id); 
			$zone_id = $workgroup->zone;
		}
		$conf['ui']->show_confirm($conf['web_path'] . "/option.php?action=delete&really=1&option_id=$option_id&type=$type&type_id=$type_id&zone_id=$zone_id","Are you sure you want to delete this DHCP option? <b>($option->dhcp_option_name with value $option->value)</b>");
	}

        /*!
                @function show_create_global
                @discussion shows you the create global workgroup options
        */
        elseif ($action == 'show_create_global') {
                require($conf['prefix'] . "/templates/show_global_option.inc");
        }


?>

<?php show_template('footer'); ?>
