<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: lib.php,v 1.62 2003/08/03 23:48:06 vollmerk Exp $
 $Source: /data/cvsroot/maint/modules/lib.php,v $

 These are the supporting functions for maint.

*/

// This function is used to setup the user environment whenever
//    they visit a page ... it is intended to be run after check_session
//    and before any work actually happens.
function setup_user_environment ($action = false, $zone_id = 0) {
	global $conf, $user;

	// First create the user object from $_SESSION['user']
	$user = $_SESSION['user'];
	$user->set_from_db();
	
	$conf['color'] = new Color($user->color_template);
	
	// If they are autoreg'in and they've set the autoreg_type
	if ($conf['modules']->modules['autoreg']->enabled) {
		if ($_REQUEST['autoreg_type']) { 
			$user->autoreg_type = $_REQUEST['autoreg_type']; 
		} 
	}

	// first thing's first, check for the gone fishing file
	if ( file_exists($conf['prefix'] . "/build/gone.fishing") ) {
		show_template('gonefishing');
		exit();
	}

	// choose a zone here
	if ( $_REQUEST['action'] == 'Go!' && $_REQUEST['zone_id'] && $user->has_access($_REQUEST['zone_id']) ) {
		$conf['zone'] = new Zone($_REQUEST['zone_id']);

		//check and reset if they are a zone admin or not.
		$zone_id = $conf['zone']->id;
	
		$user->current_zone = $_REQUEST['zone_id'];

		//sets is_admin,is_zone_admin,is_user,is_guest
		$user->set_access_level($_REQUEST['zone_id']);
	}

	elseif ( $user->current_zone ) {
		$conf['zone'] = new Zone($user->current_zone);
	}
	elseif ( $user->preferred_zone AND $user->has_read_access($user->preferred_zone) ) {
		$conf['zone'] = new Zone($user->preferred_zone);
		$user->set_access_level($conf['zone']->id);
	}
	else {
		$zones = $user->zones();
		$conf['zone'] = new Zone($zones[0]->id);
		$user->set_access_level($conf['zone']->id);
	}

	$conf['action'] = $_REQUEST['action'];
	$conf['script'] = $SCRIPT_NAME;

	// if they don't specify an action we want to clear the user view
	//    so it doesn't inherit the current view for a different list.
	if ( ! $action ) {
		$user->view  = false;
	}

	// let's make our other objects we'll need here as well
	$conf['ui']    = new UI();
	$conf['error'] = new Error();
	$conf['help']  = new Help();

	// we have established this person as a real user
	$conf['max_list'] = $user->list_view;

	//If they have canceled something then redirect off to a template
	if ( $action == 'Cancel' ) {
		require $conf['prefix'] . "/templates/show_cancel.inc";
		exit();
	} //cancel

}


function show_template ( $template ) {
        global $conf, $user;

        require $conf['prefix'] . "/templates/$template.inc";
}

/*
 Pull all the IP ranges from IP_blocks and then slowly count through them
 Creating empty ranges
*/

function get_available_ranges () {
	global $conf;

	//Get IP Blocks
	$sql = "SELECT * FROM ip_blocks WHERE enabled='true'";
	$db_results = mysql_query($sql, $conf['dbh']);

	while ($r = mysql_fetch_object($db_results)) {
		$ip_blocks[] = $r;
	}

	$ip = new IP(0);

	//go through all ip blocks
	foreach ($ip_blocks as $ip_block) { 

		$ip_block_count = $ip_block->start;
		$range_start = $ip_block_count;
	
		while ($ip_block->end >= $ip_block_count) {

			$range_end = $ip_block_count;

			$sql = "SELECT end FROM ranges WHERE start='$ip_block_count'";	
			$db_results = mysql_query($sql, $conf['dbh']);

			//if there is a range there.... 
			//reset range_start and set ip_block_count to +1 end of range
			if ($r = mysql_fetch_object($db_results)) {

				//if they has been at least 2 empty IP
				//create a new range object manualy
				if ($range_start != $range_end-1 AND $range_start+1 != $range_end-1) { 
					$range->start_int = $range_start;
					$range->start     = $ip->int2ip($range_start);

					//the end is current - 1 (we found a range on this one so get the one right before
					$range->end_int = $range_end-1;
					$range->end     = $ip->int2ip($range_end);
		
					//set the "total ips" in this range
					$range->total = ($range_end - 1) - $range_start;

					//add it to the ranges array
					$ranges[] = $range;
					
				} //end start != end and start+1 != end
				
				//now reset the vars to the end of the found range account for the subnet
				//we have to account for the fact that end+1 will be the gateway address
				$range_start = $r->end + 2;
				$ip_block_count = $r->end+2;

			} //if something is found

			$ip_block_count++;

		} //end while inside ip_block


	} //foreach ip_blocks

	return $ranges;


} // get_available_ranges


// see get_available
function get_available_subnets () {

        global $conf;

        //Get IP Blocks
        $sql = "SELECT * FROM ip_blocks WHERE enabled='true'";   
        $db_results = mysql_query($sql, $conf['dbh']);

        while ($r = mysql_fetch_object($db_results)) {
                $ip_blocks[] = $r;
        }

        $ip = new IP(0);

        //go through all ip blocks
        foreach ($ip_blocks as $ip_block) {

                $ip_block_count = $ip_block->start;
                $subnet_start = $ip_block_count;

		//Make this here we will need it for later
		$max_netmask = $ip->ip2int('255.255.255.255');

                while ($ip_block->end >= $ip_block_count) {

                        $subnet_end = $ip_block_count;

                        $sql = "SELECT subnet,netmask FROM subnet WHERE subnet='$ip_block_count'";
                        $db_results = mysql_query($sql, $conf['dbh']);

                        //if there is a range there....
                        //reset range_start and set ip_block_count to +1 end of range
                        if ($r = mysql_fetch_object($db_results)) {

                                //if they has been at least 1 empty IP
                                //create a new range object manualy
                                if ($subnet_start != $subnet_end) {
					//we add 1 so it includes each end.. 1 to 5 is 5 possible not 4
                                        $subnet->start     = $ip->int2ip($subnet_start);
					$diff = $subnet_end - ( $subnet_start + 1 );
				
					$netmask = $max_netmask - $diff;

                                        //now current get the one right before
                                        $subnet->netmask = $ip->int2ip($netmask);

                                        $subnets[] = $subnet;

                                } //end start != end

				//get the total number of ip's in said subnet
				$diff = $max_netmask - $r->netmask;
				
                                //now reset the vars to the end of the found range account for the subnet
                                $subnet_start = $r->subnet + $diff + 1;
                                $ip_block_count = $subnet_start - 1;

                        } //if something is found

                        $ip_block_count++;

                } //end while inside ip_block


        } //foreach ip_blocks

        return $subnets;

} // get_available_subnets


//break a hostname into a server and a name and return an object
function split_hostname($hostname) {
	global $conf, $user;

	//first we need to break out the "NAME" this should be everything before the frist dot
	$raw_data = preg_split("/\./",$hostname);
	$object->name = $raw_data[0];

	//now let's get everything after the first dot. This should be the domain.
	//so a substr starting at the postition of the first dot +1 (we don't want the dot)
	$object->domain = substr($hostname, (strpos($hostname,".")+1),strlen($hostname));

	//we should be done return the object 
	return $object;

} //split_hostname

// this takes off the X levels of the domain
// from cla.orst.edu it would take .edu for 1 level
// .orst.edu for two levels
function split_domain($domain,$level) {
	

	// Due to how split works decrease it by one
	// On john.cla.orst.edu value of 1 gives you orst.edu 
	// while in domain land it should give you only edu
	$level = $level - 1;

	// Get preiod count so we can split on 
	// count - level periods
	$count = substr_count($domain,".") + 1;

	$data = split("\.",$domain,$count-$level);
	
	// Destroy the last bit, thats the part we don't care about
	array_pop($data);
	$data = implode(".",$data);
	
	return $data;
	
} //split_domain


// count functions
	// count_cname, find total cnames or cnames per zone
	function count_cname($zone_id = 0) {
		global $conf;

	        if ($zone_id) {
		        $sql = "SELECT id FROM zone_cname WHERE zone='$zone_id'";
	        }
	        else {
			$sql = "SELECT id FROM zone_cname";
	        }

                $db_results = mysql_query($sql, $conf['dbh']) or Die (mysql_error());
                $count = mysql_num_rows($db_results);

        return $count;

        } // count_cname

	/*!
		@function count_pointer
		@discussion count all pointers in $zone_id or all if no zone specified
	*/
	function count_pointer($zone_id = 0) {
		global $conf;

		if ($zone_id) { 
			$sql = "SELECT id FROM pointer WHERE zone='$zone_id'";
		}
		else {
			$sql = "SELECT id FROM pointer";
		}

		$db_results = mysql_query($sql, $conf['dbh']);
		$count = mysql_num_rows($db_results);

	return $count;

	} // count_pointer

	/*!
		@function count_ranges
		@discussion give the total number of ranges in maintain
	*/
	function count_ranges() {
		global $conf;

		$sql = "SELECT count(id) FROM ranges";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		$results = mysql_fetch_row($db_results);

		return $results[0];

	} // count_ranges

	// count_mx, either find the total mx records or mx per zone
	function count_mx($zone_id = 0)
	{
		global $conf, $user;

		if ($zone_id)
		{
		$sql = "SELECT id FROM zone_mx WHERE zone=" . $zone_id;
		}
		else
		{
		$sql = "SELECT id FROM zone_mx";
		}
		$db_results = mysql_query($sql, $conf['dbh']);
		$count = mysql_num_rows($db_results);

	return $count;

	} // count_mx
	
        // count_hosts, either find total hosts or hosts per zone
        function count_host($zone_id = 0)
        {
                global $conf, $user;

                if ($zone_id)
                {
                $sql = "SELECT count(*) FROM host WHERE zone='$zone_id'";
                $db_results = mysql_query($sql, $conf['dbh']);
		$count = mysql_fetch_row($db_results);
                }
                else
                {
                $sql = "SELECT count(*) FROM host";
                $db_results = mysql_query($sql, $conf['dbh']);
                $count = mysql_fetch_row($db_results);
                }
        return $count[0];

        } // count_host

	//give me a count of all of the zones
function count_zone($zone_id = 0) 
{
	global $conf, $user;

        // if we are only looking for my zones then...
        if ($zone_id) {
	        $zones = $user->zones();
                $count = count($zones);
        }
        // otherwise were looking for total zones
        else {
        $sql = "SELECT id FROM zone ";
        $db_results = mysql_query($sql, $conf['dbh']);
        $count = mysql_num_rows($db_results);
        }

return $count;

} // count_zone

        //counts the current number of active users of maint
        function count_user()
        {
                global $conf,$user;

                $sql = "SELECT username FROM user";
                $db_results = mysql_query($sql, $conf['dbh']);
                $count = mysql_num_rows($db_results);
                return $count;
        } // count_user

        // function to count the number of domains
        function count_domain ($zone_id = 0)
        {
                global $conf, $user;

                // Only domains in current zone
                if ($zone_id)
                {
		$sql = "SELECT count(*) FROM zone_domain WHERE zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);
		$count = mysql_fetch_row($db_results);
                }
                else {
                $sql = "SELECT count(*) FROM domain";
                $db_results = mysql_query($sql, $conf['dbh']);
                $count = mysql_fetch_row($db_results);
                }

        return $count[0];
        } // count_domain

	function count_dynamic_ip () {
		global $conf;

		$sql = "SELECT count(*) FROM host WHERE dynamic_range>'0' AND ip='0'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$count = mysql_fetch_array($db_result);
		return $count[0];
	}

	function count_static_ip () {
		global $conf;

		$sql = "SELECT count(*) FROM host WHERE ip>'0' AND dynamic_range='0'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$count = mysql_fetch_array($db_result);
		return $count[0];
	}

	function count_free_ip () {

	}

function count_soa () {
	global $conf;

	$sql = "SELECT count(*) FROM soa";
	$db_result = mysql_query($sql, $conf['dbh']);
	$count = mysql_fetch_row($db_result);

	return $count[0];
}

// Several functions that don't have a home anywhere else


// $domain is domain_id and server is a string (fqdn of nameserver)
//    This is usually used for delegations (see insert_nameserver in
//    class SOA for adding nameservers to SOA's)
function insert_nameserver ( $domain, $server ) {
	global $conf;

	$sql = "INSERT INTO record_ns (name,domain) VALUES ('$server', $domain)";
	$db_result = mysql_query($sql, $conf['dbh']);

	return mysql_insert_id($conf['dbh']);
}

function insert_soa ($domain, $primary_master, $mail_address, $refresh, $retry, $expire, $ttl) {
	global $conf;

	$sql = "INSERT INTO soa (domain,primary_master,mail_address,refresh,retry,expire,ttl) ".
		"VALUES ($domain, '$primary_master', '$mail_address', '$refresh', '$retry', '$expire', '$ttl')";
	$db_result = mysql_query($sql, $conf['dbh']);

	return mysql_insert_id($conf['dbh']);
}

// This will return an array of all SOA objects in the database
//
function get_soa () {
	global $user, $conf;

	$sql = "SELECT id FROM soa";

	if ( $user->view ) {
		$sql .= $user->view->get_query();
	}

	$db_result = mysql_query($sql, $conf['dbh']);

	$soas = array();

	while ( $soa_id = mysql_fetch_object($db_result) ) {
		$soa = new SOA($soa_id->id);
		$soas[] = $soa;
	}

	return $soas;
}

// This will return an array of all Domain objects in the database
//   that aren't associated with an SOA (and hence delegated)
function get_delegated_domains () {
	global $conf;

	$sql = "SELECT DISTINCT record_ns.domain FROM record_ns LEFT JOIN soa ON".
		" record_ns.domain=soa.domain WHERE soa.id IS NULL";
	$db_result = mysql_query($sql, $conf['dbh']);

	$domains = array();

	while ( $domain_obj = mysql_fetch_object($db_result) ) {
		$domain = new Domain($ns_obj->domain);
		$domains[] = $domain;
	}

	return $domains;
}

// This will build a CSV file with all of the hosts passed to it
//   and then mail it off to the named user.
function deliver_csv ($email, $zone, $hosts=0,$cnames=0,$mxs=0,$flos=0) {
	global $conf;


	//if the hosts is set send a host report
	if ($hosts) { 
	$mail_body  = "# format for this file is the following\n";
	$mail_body .= "hostname,ip,hardware address,operating system,hardware type,location,serial number,host status,bandwidth rate,purchase date,po number,warranty date,owning unit,other id,last seen\n";

	foreach ($hosts as $host) {
		$domain  = $host->domain->name;
		$ip_addr = $host->ip->ip_addr;
		$date = date("m\/d\/Y H:i:s",$host->last_seen);
		if ($ip_addr <= "0") { $ip_addr = "Dynamic"; } 

		//we need to do a str_replace for ,'s do they don't breka the csv
		$host->os 			= str_replace(",","_",$host->os);
		$host->type 			= str_replace(",","_",$host->type);
		$host->location 		= str_replace(",","_",$host->location);
		$host->serial			= str_replace(",","_",$host->serial);
		$host->other_id			= str_replace(",","_",$host->other_id);

		$mail_body .= "$host->name.$domain,$ip_addr,$host->ha,$host->os,$host->type,$host->location,$host->serial,$host->status,$host->bandwidth_rate,$host->purchase_date,$host->po_number,$host->warranty_date,$host->owning_unit,$host->other_id,$date\n";
	}

	mail ($email, "CSV Host Report of $zone", $mail_body, 
                "From: $email\r\n" .
                "X-Mailer: NET Mail Gateway PHP/" . phpversion());

	} //end host report

	//if the cnames are set send a cname report
	if ($cnames) {
	$mail_body  = "# format for this file is the following\n";
        $mail_body .= "# hostname,cname server\n";

        foreach ($cnames as $cname) {
                $mail_body .= "$cname->hostname,$cname->server\n";
        }

        mail ($email, "CSV Cname Report of $zone", $mail_body,
                "From: $email\r\n" .
                "X-Mailer: NET Mail Gateway PHP/" . phpversion());
	} //end cname report

        //if the mxss are set send a mx report
        if ($mxs) {
        $mail_body  = "# format for this file is the following\n";
        $mail_body .= "# hostname,mx server,priority\n";

        foreach ($mxs as $mx) {
                $mail_body .= "$mx->hostname,$mx->server,$mx->priority\n";
        }

        mail ($email, "CSV MX Record Report of $zone", $mail_body,
                "From: $email\r\n" .
                "X-Mailer: NET Mail Gateway PHP/" . phpversion());

        } //end mx report

        //if there are flos set send a flo report
        if ($flos) {
        $mail_body  = "# format for this file is the following\n";
        $mail_body .= "date,hostname,domain,os,location,hardware type,serial,other_id,ip,in_kb,out_kb,in_packets,out_packets\n";

        foreach ($flos as $flo) {
		$date = date("m\/d\/Y",$flo->date);
		$hostname = $flo->host->name;
		$ip_addr = $flo->host->ip->ip_addr;
		$serial = $flo->host->serial;
		$os = $flo->host->os;
		$location = $flo->host->location;
		$other_id = $flo->host->other_id;
		$domain = $flo->host->domain->name;

		$os 			= str_replace(",","_",$os);
		$type 			= str_replace(",","_",$type);
		$location 		= str_replace(",","_",$location);
		$serial			= str_replace(",","_",$serial);
		$other_id		= str_replace(",","_",$other_id);

                $mail_body .= "$date,$hostname,$domain,$os,$location,$type,$serial,$other_id,$ip_addr,$flo->in_kb,$flo->out_kb,$flo->in_packets,$flo->out_packets\n";
        }

        mail ($email, "CSV Bandwidth Usage Report of $zone", $mail_body,
                "From: $email\r\n" .
                "X-Mailer: NET Mail Gateway PHP/" . phpversion());

        } //end flos report


} //deliver_csv

// This function simply takes a number and puts commas every 3.
function commify($int) {
	global $conf;
	$count = intval(strlen($int)/3);
	if ($count == strlen($int)/3) { $count -= 1; }
	$i=1;
	while ($i <= $count) {
		$int = substr_replace($int, ",",((strlen($int)-$b)-(3 * $i)),0);
		$i++;
		$b++;
		}
	return $int;


} //commify
?>
